=== debian/changelog ===
avogadro (1.2.0-1+deb9u1) stretch; urgency=medium

  [ Anton Gladky ]
  * Update eigen3 patches, pull them from upstream. (Closes: #865085)

 -- Michael Banck <mbanck@debian.org>  Thu, 13 Jul 2017 10:15:00 +0200

avogadro (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Merge with experimental.
  * debian/patches/nwchem_input_ccsd.patch: Removed, no longer needed.
  * debian/patches/hurd_ftbfs.patch: Likewise.
  * debian/patches/use_python_include_dirs.patch: Likewise.
  * debian/patches/fix_build_failure.patch: Likewise.
  * debian/patches/libmsymfloat.patch: New patch, fixes a build failure, taken
    from upstrem issue #836 by Henrique Junior.
  * debian/patches/boost148.patch: Updated.
  * debian/patches/link_to_libgl2ps.patch: Likewise.
  * debian/patches/probe-X11-paths-with-find_package.patch: Refreshed.
  * debian/patches/eigen3.patch: Updated, taken from upstream pull request #38.

 -- Michael Banck <mbanck@debian.org>  Sun, 02 Oct 2016 10:13:37 +0200

avogadro (1.1.1-1~exp6) experimental; urgency=medium

  * debian/rules (override_dh_strip): Removed target.

 -- Michael Banck <mbanck@debian.org>  Sun, 25 Sep 2016 14:27:43 +0200

avogadro (1.1.1-1~exp5) experimental; urgency=medium

  * debian/changelog: Merge changes from unstable.
  * debian/control: Likewise.

 -- Michael Banck <mbanck@debian.org>  Sun, 25 Sep 2016 11:52:06 +0200

avogadro (1.1.1-1~exp4) experimental; urgency=medium

  * debian/patches/fix-qreal-vs-double.patch: New patch, fixes qreal VS double
    issue, by Peter Green. (Closes: #838733)

 -- Michael Banck <mbanck@debian.org>  Sun, 25 Sep 2016 11:05:55 +0200

avogadro (1.0.3-14) unstable; urgency=medium

  * Acknowledge NMU.
  * debian/patches/boost148.patch: Updated with further hunks skipping
    inclusion of <boost/python.hpp> during MOC runs (Closes: #833770).
  * debian/patches/fix_build_failure.patch: New patch, fixes a build failure,
    taken from the 1.2.0 release.

 -- Michael Banck <mbanck@debian.org>  Sat, 24 Sep 2016 14:57:50 +0200

avogadro (1.1.1-1~exp3.1) experimental; urgency=medium

  * Non-maintainer upload.
  * "Fix" GCC version check up to GCC 9. Closes: #812265.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Aug 2016 19:06:58 +0200

avogadro (1.0.3-13.1) unstable; urgency=medium

  * Non-maintainer upload.
  * "Fix" GCC version check up to GCC 9. Closes: #812265.

 -- Matthias Klose <doko@debian.org>  Tue, 02 Aug 2016 11:46:17 +0200

avogadro (1.0.3-13) unstable; urgency=medium

  * Add myself to uploaders.
  * Update eigen3-patch. Drop EIGEN2_SUPPORT.

 -- Anton Gladky <gladk@debian.org>  Sun, 27 Sep 2015 07:56:31 +0200

avogadro (1.0.3-12) unstable; urgency=medium

  * debian/control (libavogadro-dev/Depends): Replaced libeigen2-dev by
    libeigen3-dev.
  * debian/upstream: Move to ...
  * debian/upstream/metadata: ... here.
  * debian/control (Standards-Version): Bumped to 3.9.6.

 -- Michael Banck <mbanck@debian.org>  Fri, 18 Sep 2015 09:57:47 +0200

avogadro (1.0.3-11) unstable; urgency=medium

  * debian/upstream: Added eprint URL.
  * Acknowledge NMU.
  * debian/patches/probe-X11-paths-with-find_package.patch: New patch, fixes
    cmake no longer automatically doing X11 detection, adopted from a patch by
    Andy Whitcroft (Closes: #790859).

 -- Michael Banck <mbanck@debian.org>  Thu, 17 Sep 2015 12:50:24 +0200

avogadro (1.1.1-1~exp3) experimental; urgency=medium

  * [030ee70] Fix eigen3 dependency.

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Sep 2015 15:29:38 +0200

avogadro (1.1.1-1~exp2) experimental; urgency=medium

  * [ff93007] Use eigen3 >>3.3.

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Sep 2015 13:42:01 +0200

avogadro (1.1.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * Fix compilation against eigen3.3. (Closes: #786355)
    Thanks to Kirill Okhotnikov for assistance.
  * Use libeigen3-dev instead of libeigen2-dev. (Closes: #776914)
  * Merge Ubuntu-changes.

 -- Anton Gladky <gladk@debian.org>  Wed, 09 Sep 2015 20:38:14 +0200

avogadro (1.0.3-10.1) unstable; urgency=low

  * Non-maintainer upload.
  * Replace eigen2 by eigen3. (Closes: #728610)

 -- Anton Gladky <gladk@debian.org>  Sun, 03 Nov 2013 16:28:19 +0100

avogadro (1.0.3-10) unstable; urgency=low

  [ Daniel Leidert ]
  * debian/rules (override_dh_auto_configure): Drop setting of
    -DPYTHON_INCLUDE_DIRS. This didn't work on other architectures than amd64.
  * debian/patches/series: Don't use the use_python_include_dirs.patch patch.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sun, 02 Jun 2013 14:55:17 +0200

avogadro (1.0.3-9) unstable; urgency=low

  [ Daniel Leidert ]
  * debian/rules (override_dh_auto_configure): Try to fix the recently
    introduced FTBFSes (really closes: #710703).
  * debian/patches/use_python_include_dirs.patch: Reverted to 1.0.3-7.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sun, 02 Jun 2013 02:30:46 +0200

avogadro (1.0.3-8) unstable; urgency=low

  [ Daniel Leidert ]
  * debian/control (Vcs-Browser, Vcs-Svn): Fixed vcs-field-not-canonical.
  * debian/rules: Try to fix an FTBFS if several Python versions are installed
    (closes: Bug#710703) and don't FTBFS if there is no multi-arch Python.
  * debian/patches/use_python_include_dirs.patch: Updated.
    - Removed patch to cmake/modules/PythonDeps.cmake.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sat, 01 Jun 2013 23:28:47 +0200

avogadro (1.0.3-7) unstable; urgency=low

  [ Daniel Leidert ]
  * Ack NMU.
  * debian/rules: Prepare for Python multiarch.
    (override_dh_auto_configure): Adjusted likewise.
  * debian/patches/use_python_include_dirs.patch: Enabled (closes: #708639).
  * debian/patches/series: Adjusted.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Thu, 30 May 2013 00:04:44 +0200

avogadro (1.0.3-6.1) unstable; urgency=low

  * Non maintainer upload.
  * Fix to build with the libpython multiarch location.


