=== debian/watch ===
# See uscan(1) for format

version=3
opts=uversionmangle=s/_(rc\d+)/~\1/g \
http://sf.net/avogadro/avogadro-([\d.]+(?:_rc\d+)?)\.tar\.(?:bz2|gz)
